Difference between revisions of "Documentation/Building Guide AOO/Building on Windows"

From Apache OpenOffice Wiki
Jump to: navigation, search
(Overview)
 
(9 intermediate revisions by 4 users not shown)
Line 13: Line 13:
 
For general information on how to build Apache OpenOffice from source code, see the [[Documentation/Building_Guide_AOO|platform independent page]].
 
For general information on how to build Apache OpenOffice from source code, see the [[Documentation/Building_Guide_AOO|platform independent page]].
  
{{Template:Documentation/Windows|This document explains the platform specific details.}}
+
{{Win|This document explains the platform specific details.}}
 
For building Apache OpenOffice the [http://www.cygwin.com Cygwin environment] is required.  Cygwin is a set of programs that run on Windows but emulate a complete Unix command line environment.  
 
For building Apache OpenOffice the [http://www.cygwin.com Cygwin environment] is required.  Cygwin is a set of programs that run on Windows but emulate a complete Unix command line environment.  
  
As compiler we use Microsoft's Visual C++ 2008, not the gcc from Cygwin.  Therefore Visual Studio Express/Professional (version 2008 or later) can be used for debugging.
+
As compiler we use Microsoft's Visual C++ 2008 SP1, not the gcc from Cygwin.  Therefore Visual Studio Express/Professional (version 2008 or later) can be used for debugging.
  
 
To use this document you should be familiar with a bourne command line interpreter (sh or bash), but you need not be a UNIX shell wizard.
 
To use this document you should be familiar with a bourne command line interpreter (sh or bash), but you need not be a UNIX shell wizard.
{{Template:Documentation/Tip|If you have never used a Unix shell, you might want to take a look at the [http://tldp.org/LDP/GNU-Linux-Tools-Summary/html/index.html shell introduction at TLDP].}}
+
{{Tip|If you have never used a Unix shell, you might want to take a look at the [http://tldp.org/LDP/GNU-Linux-Tools-Summary/html/index.html shell introduction at TLDP].}}
  
 
=Build requirements=
 
=Build requirements=
Line 49: Line 49:
 
|-
 
|-
 
| Microsoft Visual C++ 2008 SP1 Redistributable Package (x86)
 
| Microsoft Visual C++ 2008 SP1 Redistributable Package (x86)
| vcredist_x86.exe, download found [http://www.microsoft.com/en-us/download/search.aspx?q=Microsoft%20Visual%20C%2b%2b%202008%20Redistributable%20Package&p=0&r=10&t=&s=availabledate~Descending here]
+
| vcredist_x86.exe, download found [https://www.microsoft.com/en-us/download/details.aspx?id=26368 here]
 
It is just packed as it is into the installation package.
 
It is just packed as it is into the installation package.
  
 
The exact download URL may have changed. In that case you have to search Microsoft's website.
 
The exact download URL may have changed. In that case you have to search Microsoft's website.
 +
 +
{{Warn|Make sure you install the latest update.}}
 +
 
| main/external/vcredist
 
| main/external/vcredist
 
|-
 
|-
 
| Microsoft Visual C++ 2008 SP1 Redistributable Package (x64)
 
| Microsoft Visual C++ 2008 SP1 Redistributable Package (x64)
| vcredist_x64.exe, download found [http://www.microsoft.com/en-us/download/search.aspx?q=Microsoft%20Visual%20C%2b%2b%202008%20Redistributable%20Package&p=0&r=10&t=&s=availabledate~Descending here]
+
| vcredist_x64.exe, download found [https://www.microsoft.com/en-us/download/details.aspx?id=26368 here]
 
It is just packed as it is into the installation package.
 
It is just packed as it is into the installation package.
  
 
The exact download URL may have changed. In that case you have to search Microsoft's website.
 
The exact download URL may have changed. In that case you have to search Microsoft's website.
 +
 +
{{Warn|Make sure you install the latest update.}}
 +
 
| main/external/vcredist
 
| main/external/vcredist
 
|-
 
|-
Line 98: Line 104:
 
|  
 
|  
 
|-
 
|-
| Unicode NSIS, version 2.46.5
+
| NSIS, version >= 3.0
| http://code.google.com/p/unsis/downloads/detail?name=nsis-2.46.5-Unicode-setup.exe&can=2&q=
+
| Since branch AOO413 and trunk revision 1766031, NSIS version 3.0 or greater is required if you want to build a Windows installer.
 +
http://nsis.sourceforge.net/Download
  
If Unicode NSIS is available, a self contained Windows installer is created in addition to the MSI installer files - it is optional
+
For previous versions, use Unicode NSIS, version 2.46.5 from http://code.google.com/p/unsis/downloads/detail?name=nsis-2.46.5-Unicode-setup.exe&can=2&q=
 
|  
 
|  
 
|}
 
|}
Line 119: Line 126:
 
=Remarks=
 
=Remarks=
  
{{Template:Documentation/Note|OOo uses some Mozilla libraries. Building the corresponding sources is only possible with the VC2003 compiler so you have to use precompiled libraries that require the msvx71 libraries mentioned above. On Windows the Mozilla libraries are needed only for Mozilla address book support. Unfortunately a bug in the module dependencies makes it necessary that the Mozilla libaries are used anyway as otherwise building the module <tt>xmlsecurity</tt> fails.}}
+
{{Note|OOo uses some Mozilla libraries. Building the corresponding sources is only possible with the VC2003 compiler so you have to use precompiled libraries that require the msvx71 libraries mentioned above. On Windows the Mozilla libraries are needed only for Mozilla address book support. Unfortunately a bug in the module dependencies makes it necessary that the Mozilla libaries are used anyway as otherwise building the module <tt>xmlsecurity</tt> fails.}}
  
 
= Setting up Cygwin =
 
= Setting up Cygwin =
  
 
Go to http://www.cygwin.com/ and download and install the current 32bit version.
 
Go to http://www.cygwin.com/ and download and install the current 32bit version.
{{Template:Documentation/Caution|Make sure that you keep the filetype set to “Unix/binary”.}}
+
{{Warn|Make sure that you keep the filetype set to “Unix/binary”.}}
{{Template:Documentation/Caution|Make sure that the PATH variable in your cygwin shell does not contain any unquoted blanks and quotes, otherwise configure will not work}}
+
{{Warn|Make sure that the PATH variable in your cygwin shell does not contain any unquoted blanks and quotes, otherwise configure will not work}}
  
  
Line 144: Line 151:
 
** patch
 
** patch
 
** readline
 
** readline
** subversion (if you want to use svn inside the cygwin shell to checkout and update your working copy of AOO)
+
** subversion (if you want to use svn inside the cygwin shell to checkout and update your working copy of AOO (which is highly recommended as Windows Tools can mess up Line breaks))
 +
* Category Libs
 +
** libexpat-devel
 
* Category Net
 
* Category Net
 
** openssh
 
** openssh
Line 157: Line 166:
 
** wget
 
** wget
  
{{Template:Documentation/Note|The installer will automatically check and download some more packages needed by whose listed here. The whole process takes roughly 20 minutes.}}
+
{{Note|The installer will automatically check and download some more packages needed by whose listed here. The whole process takes roughly 20 minutes.}}
  
 
=== Breaking links to executable ===
 
=== Breaking links to executable ===
Line 184: Line 193:
 
If this command is executed the first time CPAN will ask for configuration. Choose autoconfiguration.  
 
If this command is executed the first time CPAN will ask for configuration. Choose autoconfiguration.  
  
{{Template:Documentation/Caution|Please note that CPAN is not able to deal with usernames containing spaces. To work around this fact, when CPAN asks you to specify the ''CPAN build and cache directory'', change the default suggestion to <tt>/cpan</tt>.}}
+
{{Warn|Please note that CPAN is not able to deal with usernames containing spaces. To work around this fact, when CPAN asks you to specify the ''CPAN build and cache directory'', change the default suggestion to <tt>/cpan</tt>.}}
  
 
At the end the CPAN shell appeared and is ready to accept commands for installations. Each module is installed by typing <code>install $MODULENAME</code>. The modules that must be installed are:
 
At the end the CPAN shell appeared and is ready to accept commands for installations. Each module is installed by typing <code>install $MODULENAME</code>. The modules that must be installed are:
Line 194: Line 203:
 
CPAN will detect if a selected module depends on other modules and it will offer to download them also. As explained please just confirm this.
 
CPAN will detect if a selected module depends on other modules and it will offer to download them also. As explained please just confirm this.
  
{{Template:Documentation/Caution|I got an error message from CPAN somewhat like the following:
+
{{Warn|I got an error message from CPAN somewhat like the following:
 
<pre>C:\cygwin\bin\perl.exe: *** unable to remap C:\cygwin\bin\cygiconv-2.dll to same
 
<pre>C:\cygwin\bin\perl.exe: *** unable to remap C:\cygwin\bin\cygiconv-2.dll to same
 
address as parent(0x7C0000) != 0x7D0000</pre>
 
address as parent(0x7C0000) != 0x7D0000</pre>
To fix this, I had to exit the Cygwin shell, run cmd.exe, then type "c:\cygwin\bin\ash.exe" to start the minimal shell, then type <code>/bin/rebaseall</code>. Then CPAN worked when I ran it again.}}
+
To fix this, I had to exit the Cygwin shell, run cmd.exe, then type "c:\cygwin\bin\ash.exe" to start the minimal shell, then type <code>/bin/rebaseall</code>. Then CPAN worked when I ran it again.
 +
 
 +
If you can't install LWP::UserAgent because of libwww-perl copy, gcc and g++ compiler.
 +
<pre>
 +
cd /usr/bin
 +
cp gcc.exe gcc-4.exe
 +
cp g++.exe g++-4.exe
 +
</pre>
 +
}}
  
 
= Configure switches (Windows specific) =
 
= Configure switches (Windows specific) =

Latest revision as of 10:10, 16 July 2018

Template:Documentation/Building Guide AOO TOC

Overview

For general information on how to build Apache OpenOffice from source code, see the platform independent page.

Documentation windows.png This document explains the platform specific details.

For building Apache OpenOffice the Cygwin environment is required. Cygwin is a set of programs that run on Windows but emulate a complete Unix command line environment.

As compiler we use Microsoft's Visual C++ 2008 SP1, not the gcc from Cygwin. Therefore Visual Studio Express/Professional (version 2008 or later) can be used for debugging.

To use this document you should be familiar with a bourne command line interpreter (sh or bash), but you need not be a UNIX shell wizard.

Tip.png If you have never used a Unix shell, you might want to take a look at the shell introduction at TLDP.


Build requirements

Additionally to the general build requirements you need

What Where to get How to install
Windows 7 (recommended), Windows Vista, Windows XP
Cygwin http://www.cygwin.com, 32bit version, minimum version: 1.5.10, preferred: current version]

See below for setting up cygwin and the required packages.

(default)
Microsoft Windows SDK for Windows 7 and .NET Framework 3.5 SP1 http://www.microsoft.com/en-us/download/details.aspx?id=3138

It brings the Visual Studio 2008 C++ compiler with it.

This is either a DVD image or a net installer. You can either mount the DVD with a suitable tool, burn it do a DVD or use tools like winrar or 7zip to extract files from the ISO file directly. You don't need to install samples or documentation (saves a lot of disk space). It will also install the .NET Framework 3.5 SDK. It might be best to install the Windows SDK into the default directory, and if not that into one without capital letters in the path.

Microsoft Visual C++ 2008 SP1 Redistributable Package (x86) vcredist_x86.exe, download found here

It is just packed as it is into the installation package.

The exact download URL may have changed. In that case you have to search Microsoft's website.

Documentation caution.png Make sure you install the latest update.
main/external/vcredist
Microsoft Visual C++ 2008 SP1 Redistributable Package (x64) vcredist_x64.exe, download found here

It is just packed as it is into the installation package.

The exact download URL may have changed. In that case you have to search Microsoft's website.

Documentation caution.png Make sure you install the latest update.
main/external/vcredist
GDI+ Redistributable http://www.microsoft.com/downloads/details.aspx?familyid=6A63AB9C-DF12-4D41-933C-BE590FEAA05A&displaylang=en. Genuine Windows Validation required. main/external/gdiplus
Runtime libraries 10.0 msvcp100.dll and msvcr100.dll for Java 7 support - see issue 120979.

Get them from the Microsoft Visual C++ 2010 Redistributable Package (x86) from the Microsoft site - http://www.microsoft.com/en-us/download/search.aspx?q=Microsoft+Visual+C%2b%2b+2010+Redistributable

main/external/msvcp100
dbghelp.dll http://msdn.microsoft.com/en-us/library/windows/desktop/ms679309%28v=vs.85%29.aspx

The exact download URL may have changed. In that case you have to search Microsoft's website.

Search for it on your PC or on the web. E.g., it is part of the Windows Driver Kit.

main/external/dbghelp
Windows Driver Kit Version 7.1.0 http://www.microsoft.com/downloads/details.aspx?id=11800

To enable ATL and ActiveX in the build - it is optional

related configure options are: --with-atl-include, --with-atl-lib-dir, --with-mfc-include-dir, --with-mfc-lib-dir

Microsoft DirectX SDK http://www.microsoft.com/download/en/details.aspx?displaylang=en&id=6812

To enable DirectX in the build - it is optional

related configure option is: --with-directx-home

NSIS, version >= 3.0 Since branch AOO413 and trunk revision 1766031, NSIS version 3.0 or greater is required if you want to build a Windows installer.

http://nsis.sourceforge.net/Download

For previous versions, use Unicode NSIS, version 2.46.5 from http://code.google.com/p/unsis/downloads/detail?name=nsis-2.46.5-Unicode-setup.exe&can=2&q=

When building Apache OpenOffice 3.4.x or 4.0.x you need to provide some additional binaries:

Runtime libraries 7.1 msvcr71.dll for Mozilla libraries. Search for them on the web or on your PC. These files should be named as all lower case. Sometimes when downloaded they are upper case and this will cause 'file not found' errors towards the end of the build)) main/external/msvcp71
Runtime libraries 8.0 msvcp80.dll and msvcr80.dll for Mozilla libraries. Search for them on the web or on your PC. main/external/msvcp80

Remarks

Documentation note.png OOo uses some Mozilla libraries. Building the corresponding sources is only possible with the VC2003 compiler so you have to use precompiled libraries that require the msvx71 libraries mentioned above. On Windows the Mozilla libraries are needed only for Mozilla address book support. Unfortunately a bug in the module dependencies makes it necessary that the Mozilla libaries are used anyway as otherwise building the module xmlsecurity fails.

Setting up Cygwin

Go to http://www.cygwin.com/ and download and install the current 32bit version.

Documentation caution.png Make sure that you keep the filetype set to “Unix/binary”.
Documentation caution.png Make sure that the PATH variable in your cygwin shell does not contain any unquoted blanks and quotes, otherwise configure will not work


Additional packages for Cygwin to serve the AOO build

Cygwin consists of some basic and a lot of optional packages. As building AOO needs some of these optional packages you have to select them in the installer. Here's a complete list of the required packages:

  • Category Archive:
    • unzip
    • zip
  • Category Devel :
    • autoconf
    • bison
    • flex
    • gcc-g++
    • gperf
    • make
    • patch
    • readline
    • subversion (if you want to use svn inside the cygwin shell to checkout and update your working copy of AOO (which is highly recommended as Windows Tools can mess up Line breaks))
  • Category Libs
    • libexpat-devel
  • Category Net
    • openssh
    • openssl
  • Category Perl
  • Category Shells
    • mintty
  • Category Utils
    • gnupg
  • Category Web
    • wget
Documentation note.png The installer will automatically check and download some more packages needed by whose listed here. The whole process takes roughly 20 minutes.

Breaking links to executable

Within the Cygwin Toolkit, some executables might be symlinks: awk.exe and gunzip.exe, tar.exe (in older releases only). This can lead to a break of the build later, and the symlinks should be replaced by copies of the command they link to.

To check this, execute:

ls -l /bin/awk.exe

whether e.g. awk.exe is a symlink. In version 1.5.24-2 awk.exe is a link to gawk.exe. The shell will show this by putting out “awk.exe -> gawk.exe”. In this case gawk.exe must be copied to awk.exe by executing:

cd /bin
rm awk.exe
cp gawk.exe awk.exe

In case you overlook something here or you have a newer Cygwin version with additional symlinks not mentioned here it's not a problem. You will get a helpful error message about an existing link in the configuration step (configure) later. The message will tell you which link you have to remove and you can do it following the advice given above for the awk.exe/gawk.exe pair.


Installing additional perl modules in cygwin

As explained some perl modules must be installed with CPAN. The necessary command in the cygwin shell is

perl -MCPAN -e shell

If this command is executed the first time CPAN will ask for configuration. Choose autoconfiguration.

Documentation caution.png Please note that CPAN is not able to deal with usernames containing spaces. To work around this fact, when CPAN asks you to specify the CPAN build and cache directory, change the default suggestion to /cpan.

At the end the CPAN shell appeared and is ready to accept commands for installations. Each module is installed by typing install $MODULENAME. The modules that must be installed are:

  • Archive::Zip
  • LWP::UserAgent
  • XML::Parser (though it seems that this is already installed; doesn't hurt to do it)

CPAN will detect if a selected module depends on other modules and it will offer to download them also. As explained please just confirm this.

Documentation caution.png I got an error message from CPAN somewhat like the following:
C:\cygwin\bin\perl.exe: *** unable to remap C:\cygwin\bin\cygiconv-2.dll to same
address as parent(0x7C0000) != 0x7D0000

To fix this, I had to exit the Cygwin shell, run cmd.exe, then type "c:\cygwin\bin\ash.exe" to start the minimal shell, then type /bin/rebaseall. Then CPAN worked when I ran it again.

If you can't install LWP::UserAgent because of libwww-perl copy, gcc and g++ compiler.

cd /usr/bin
cp gcc.exe gcc-4.exe
cp g++.exe g++-4.exe

Configure switches (Windows specific)

Additionally to the general configure switches there are several that only have to be used on Windows or have Windows specific values.

Typical values for the compiler and SDK. If default installation paths are used these configure switches are not needed:

 --with-frame-home="/cygdrive/c/Program Files/Microsoft SDKs/Windows/v7.0"
 --with-psdk-home="/cygdrive/c/Program Files/Microsoft SDKs/Windows/v7.0"
 --with-midl-path="/cygdrive/c/Program Files/Microsoft SDKs/Windows/v7.0/Bin"

For DirectX:

 --with-directx-home="C:/Program Files (x86)/Microsoft DirectX SDK (June 2010)"

For ATL and ActiveX:

 --with-atl-include-dir=/cygdrive/c/WinDDK/7600.16385.1/inc/atl71
 --with-atl-lib-dir=/cygdrive/c/WinDDK/7600.16385.1/lib/ATL/i386
 --with-mfc-include-dir=/cygdrive/c/WinDDK/7600.16385.1/inc/mfc42
 --with-mfc-lib-dir=/cygdrive/c/WinDDK/7600.16385.1/lib/Mfc/i386

And some more:

 --enable-pch
 --enable-dbgutil
Personal tools